//+------------------------------------------------------------------+
//|                                                     MACD_CCI.mq4 |
//|                                   Copyright  2009, challenger78 |
//| 06/11/2009 klentz                                                |
//| CCI replaced by SMA since CCI was not really needed here         |
//+------------------------------------------------------------------+
#property  copyright "challenger78"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  DarkGreen
#property  indicator_color2  Red
#property  indicator_color3  DarkOrange

#property  indicator_minimum 0
#property  indicator_maximum 2

extern string TimeFrame = "current time frame";
extern int FastLen = 144;
extern int SlowLen = 233;
extern int SMA = 50;
extern bool UseAlert = true;
extern int AlertIterations = 1;
extern int AlertInterval = 1;
extern bool GreenRedAlertsEmail = true;
extern bool YellowAlertsEmail = false;

double buffer1[], buffer2[], buffer3[];
int BARS;
int countdown;
bool countdownStarts;
bool greenAlert = false;
bool yellowAlert = false;
bool redAlert = false;
int secondsWhenAlertLit;
int timeFrame;
int init()
{
   SetIndexStyle(0,DRAW_ARROW);    SetIndexArrow(0,110);    SetIndexBuffer(0,buffer1);    SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexStyle(1,DRAW_ARROW);    SetIndexArrow(1,110);    SetIndexBuffer(1,buffer2);    SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexStyle(2,DRAW_ARROW);    SetIndexArrow(2,110);    SetIndexBuffer(2,buffer3);    SetIndexEmptyValue(2,EMPTY_VALUE);
   timeFrame=stringToTimeFrame(TimeFrame);
   return(0);
}

int start()
{
   int limit;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = MathMax(Bars - counted_bars,2*timeFrame/Period());

   for(int i = 0; i < limit; i++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double price_typical = iMA(NULL,timeFrame,1,0,MODE_SMA,PRICE_TYPICAL,y);   
      double sma_trend = price_typical - iMA(NULL, timeFrame, SMA, 0, MODE_SMA, PRICE_TYPICAL, y);
      double ma_0 = iMA(NULL, timeFrame, FastLen, 0, MODE_EMA, PRICE_CLOSE, y) - 
                     iMA(NULL, timeFrame, SlowLen, 0, MODE_EMA, PRICE_CLOSE, y);
      double ma_1 = iMA(NULL, timeFrame, FastLen, 0, MODE_EMA, PRICE_CLOSE, y + 1) - 
                     iMA(NULL, timeFrame, SlowLen, 0, MODE_EMA, PRICE_CLOSE, y + 1);
                         
      buffer1[i]=EMPTY_VALUE;    buffer2[i]=EMPTY_VALUE;      buffer3[i]=EMPTY_VALUE;    
      
      if (sma_trend > 0 && ma_0 > ma_1) buffer1[i] = 1;  
      else if (sma_trend < 0 && ma_0 < ma_1) buffer2[i] = 1;
      else buffer3[i] = 1;
   }
   if(UseAlert == true )
   {
      if(buffer1[1] != EMPTY_VALUE && buffer1[2] == EMPTY_VALUE && buffer2[1] == EMPTY_VALUE && buffer3[1] == EMPTY_VALUE
         && Bars != BARS && Seconds() < 5)
      {
         Alert("", Symbol(), " (",Period(), ")  Trend Buy\n");
         countdown = AlertIterations-1;
         countdownStarts = true;
         secondsWhenAlertLit = Seconds();
         greenAlert = true;
         if(GreenRedAlertsEmail == true)
         {
            SendMail("From Metatrader\'s MACD SMA",
            "The MACD SMA at " + Symbol() + " (" + Period() + ") Trend Buy");
         }   
      }
      if (buffer1[1] == EMPTY_VALUE && buffer2[1] !=EMPTY_VALUE && buffer2[2] == EMPTY_VALUE && buffer3[1] == EMPTY_VALUE
          && Bars != BARS && Seconds() <5)
      {
         Alert("", Symbol(), " (",Period(), ") Trend Sell\n");
         countdown = AlertIterations-1;
         countdownStarts = true;
         secondsWhenAlertLit = Seconds();
         redAlert = true;
         if(GreenRedAlertsEmail == true)
         {
            SendMail("From Metatrader\'s MACD SMA",
            "The MACD SMA at " + Symbol() + " (" + Period() + ")Trend Sell");
         }    
      }
      if(buffer1[1] == EMPTY_VALUE && buffer2[1] == EMPTY_VALUE && buffer3[1] != EMPTY_VALUE && buffer3[2] == EMPTY_VALUE
         && Bars != BARS && Seconds() <5)
      {
         Alert("", Symbol(), " (", Period(), ") Watch for Trend Change\n");
         countdown = AlertIterations-1;
         countdownStarts = true;
         secondsWhenAlertLit = Seconds();
         yellowAlert = true;
         if(YellowAlertsEmail == true)
         {
            SendMail("From Metatrader\'s MACD SMA",
            "The MACD SMA at " + Symbol() + " (" + Period() + ") No Trend");
         }   
      }
      if(Seconds() > (secondsWhenAlertLit +AlertInterval) && greenAlert == true && countdown > 0 && countdownStarts == true)
      {
         Alert("MACD SMA is now green @ ", Symbol(), " (", Period(), ")\n");
         countdown -= 1;
         secondsWhenAlertLit = Seconds();
      }
      if(Seconds() > (secondsWhenAlertLit + AlertInterval) && yellowAlert == true && countdown > 0 && countdownStarts == true)
      {
         Alert("MACD SMA is now yellow @ ", Symbol(), " (", Period(), ")\n");
         countdown -= 1;
         secondsWhenAlertLit = Seconds();
      }
      if(Seconds() > (secondsWhenAlertLit + AlertInterval) && redAlert == true && countdown > 0 && countdownStarts == true)
      {
         Alert("MADC SMA is now red @ ", Symbol(), " (", Period(), ")\n");
         countdown -= 1;
         secondsWhenAlertLit = Seconds();
      }         
      BARS = Bars;
   }    
             
   return(0);
}
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}